MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)

--local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow

function MageManaBar_OnLoad(Frame) 
                                               
    if select(2, UnitClass("player")) ~= "MAGE" then MageManaBarBgFrame:Hide() return end
        
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
 	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 	Frame:RegisterEvent("UNIT_MAXPOWER")
    
    MMBwidth = 300
end

function MMBManabarUpdate()

	MageManaBarFrame:SetValue(UnitPower("player"))
	MageManaBarOverflowFrame:SetValue(UnitPower("player"))

end

function MMBManabarMaxPool()

    MMBmanapoolmultiplier = 1.05
    MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79061) or (spellId == 79063) then
			MMBmanapoolmultiplier = 1.1
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
                    table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
--                    print((MMBcurrentbuff[#MMBcurrentbuff])[4],(MMBcurrentbuff[#MMBcurrentbuff])[2])
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
	    for i = #MMBcurrentbuff,1,-1 do
	        
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
--	print((MMBcurrentbuff[1])[1],(MMBcurrentbuff[1])[2],(MMBcurrentbuff[1])[4],spellId)
	        if (name == nil) then
	            table.remove(MMBcurrentbuff,i)
	        end
	    end
	end
    
    --table.sort(MMBcurrentbuff, function(a,b) return )
    MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
    MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
    
    MMBmanaGem:ClearAllPoints()
    MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*(12405/MMBregmanapool)),0)
    MMBevocation:ClearAllPoints()
    MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*0.6),0)

end

function MMBmanaoverflowwarning()
	
    if (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) then
    
    	for i = #MMBcurrentbuff,1,-1 do
    	
    		MMBmanaoverflow = UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool)
    		MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
    		
    		if (MMBmanaoverflow > 0) then
		        MMBwarningtext1:SetText("MANA OVERFLOW !!")
        		MMBwarningtext2:SetText(format("%.0fmp lost in %.1f", MMBmanaoverflow, MMBbuffoverflowtimer))
        		MageManaBarBgFrame:SetWidth(MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))+2)
        		MMBoverflowflash("enable")
        		break
        	elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
        		MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
        	end
        end
        	
    else MMBwarningtext1:SetText("")
         MMBwarningtext2:SetText("")
         MMBoverflowflash("disable")
         MageManaBarBgFrame:SetWidth(MMBwidth)
    end
end

function MMBoverflowflash(command)
	
	if (command == "enable") then
		for i = 1,8 do
			_G["MMBFlash"..i]:Show()
		end
		
		MMBFlash2:SetWidth(MageManaBarBgFrame:GetWidth())
		MMBFlash6:SetWidth(MageManaBarBgFrame:GetWidth())
		
	elseif (command == "disable") and MMBFlash1:IsVisible() then
		for i = 1,8 do
			_G["MMBFlash"..i]:Hide()
		end
	end
end

	
	
	
	
MMBcurrentbuff = {}
    
MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79479, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 82175, 7200}
}
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
        MageManaBarFrame:SetStatusBarColor(0.2,0.5,0.8)
        MageManaBarOverflowFrame:SetStatusBarColor(1,0.3,0.3,0.5)
        --MMBevocationTimer:SetStatusBarColor(0.2,0.1,0.4)
        --MMBmanaGemTimer:SetStatusBarColor(0.1,0.1,0.4)
        MMBManabarMaxPool()
    end
    
    if (event == "UNIT_MAXPOWER") then
    	
    	local unit, powertype = select(1, ...)
    	
    	if (unit == "player") then
    	
    		MMBManabarMaxPool()
    		
    	end
    end
    
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then

    	local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
            
            if (sourceName == UnitName("player")) then
            	
            	if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) then
            	
            		if (MMBmageArmorgradCooldown == nil) then
            	 		CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
						MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
            	 		CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
						MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
					end

            		MMBmageArmorgradCooldown:SetCooldown(0,0)
            		MMBmageArmorCooldown:SetCooldown(GetTime(),5)
            	end
            end
	end
    
end


	
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
 
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
            
            MMBManabarUpdate()
            MMBmanaoverflowwarning()
            
            ------------------------------------- Evocation stuff
            local start, duration, enable = GetSpellCooldown(12051)
            
            if (duration <= 1.55) then
            	--MMBevocationTimer:Hide()
                --MMBevocationgradblackleft:Hide()
                --MMBevocationCDanim = 0
                if (MMBevocationCDanim == 1) then
                	MMBevocationgradCooldown:SetCooldown(0,0)
				end
				MMBevocationCDanim = 0
            else --MMBevocationTimer:Show()
                 --MMBevocationgradblackleft:Show()
            	 --MMBevocationTimer:SetMinMaxValues(0,duration)
            	 --MMBevocationTimer:SetValue(duration-(GetTime()-start))
            	 if (MMBevocationCDanim == 0) then
            	 	if (MMBevocationCooldown == nil) then
            	 		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
						MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
            	 		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
						MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
					end
					
					MMBevocationCooldown:SetCooldown(start, duration)
					MMBevocationCooldown:SetDrawEdge(enable)
					MMBevocationCDanim = 1
				end
            end
            
            
            ------------------------------------- Mana Gem stuff
            local start, duration, enable = GetSpellCooldown(5405)
            
            if (duration <= 1.55) then
            	--MMBmanaGemTimer:Hide()
                --MMBmanaGemgradblackleft:Hide()
                --MMBmanaGemTextTimer:Hide()
                if (MMBmanaGemCDanim == 1) then
                	MMBmanaGemgradCooldown:SetCooldown(0,0)
				end
                MMBmanaGemCDanim = 0
            else --MMBmanaGemTimer:Show() 
                 --MMBmanaGemgradblackleft:Show()
            	 --MMBmanaGemTimer:SetMinMaxValues(0,duration)
            	 --MMBmanaGemTimer:SetValue(duration-(GetTime()-start))
                 --MMBmanaGemTextTimer:Show()
                 --MMBmanaGemTextTimer:SetText(format("%.1f",duration-(GetTime()-start)))
            	 if (MMBmanaGemCDanim == 0) then
            	 	if (MMBmanaGemCooldown == nil) then
            	 		CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
						MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
            	 		CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
						MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
					end
					
					MMBmanaGemCooldown:SetCooldown(start, duration)
					MMBmanaGemCooldown:SetDrawEdge(enable)
					MMBmanaGemCDanim = 1
				end
            end
            
            if (UnitPower("player") < (MMBregmanapool-12405)) and (duration <= 1.55) then
            	MMBmanaGemText:SetText(format("|cffff0000Use Gem NOW !!|r"))
            else MMBmanaGemText:SetText("")
            end
            
            ------------------------------------- Mage Armor stuff
            
            MMBmageArmor:ClearAllPoints()
		    MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*0.03) + (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))),0)
			MMBmageArmorgradFrame:ClearAllPoints()
			MMBmageArmorgradFrame:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))-(MageManaBarOverflowFrame:GetWidth()*0.03),0)
			
            
   	    self.TimeSinceLastUpdate = 0

    end
end
